//Particle.h

#pragma once

#ifndef _PARTICLE_H_
#define _PARTICLE_H_

#include "vec.h"
#include "Horde3D.h"
#include "Potential.h"

#define STARTZ 1
#define Step 1.8
#define FD 15
#define DDIS 5 

class Particle
{

public:

	H3DNode node;		//horde3dʶ
	float animTime;  //󶨵ĶϢ

	int GroupID;
	Vec3f Position;	
	Vec3f noise_velocity;
	Vec3f global_velocity;
	Vec3f avoid_velocity;

	Vec3f forward;
	float speed; //velocity = forward *speed
	Vec3f velocity;
	float radius; //ײ뾶
	static Potential m_potential;

	Particle(int _GroupID, float _radius)
	{
		GroupID = _GroupID;
		node = 0;
		animTime = 0;
		radius = _radius;
		speed = 0.1;
		noise_velocity = Vec3f(0, 0, 0);
		global_velocity = Vec3f(0, 0, 0);
		avoid_velocity = Vec3f(0, 0, 0);
	}

	~Particle(void)
	{

	}

	// per frame simulation update
	Vec3f getGlobalVelocity (Vec3f _position)
	{
		//õȫٶ
		return global_velocity = m_potential.GetVelocity(_position);
		//return global_velocity = speed * m_potential.get_gradient(_position);
	}

	Vec3f getVelocity (void)
	{
		//õٶ
		return velocity = noise_velocity + global_velocity;

	}
	void updateDensity(void)
	{
		//int x = floor((Position[0] + 20) / GRIDL);
		//int y = floor((Position[1] + 20) / GRIDL)
		//int z = floor((Position[2] + 10) / GRIDL);
		m_potential.addDensity(Position, global_velocity);
		
		//ȺǰĲӦȣʹȺԱܿ   
		//for(int i=0;i<DDIS&&x+i<40;i++)
		//	potential.m_gridData[x+i][z].discomfort = FD;
	}

};

#endif //_PARTICLE_H_
